/* 		Pop up menu driver routines
                K. J. Heaven  24 Jan 89
*/
#include <alloc.h>
#include <conio.h>
#include <menu.h>
#include <graphics.h>
#include <dos.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>

extern int graphic;		/* Flag to indicate in graphic mode */


int gprintf( int *xloc, int *yloc, char *fmt, ... )
  {
    va_list  argptr;			/* Argument list pointer	*/
    char str[140];			/* Buffer to build sting into	*/
    int cnt;				/* Result of SPRINTF for return */

    va_start( argptr, format );		/* Initialize va_ functions	*/

    cnt = vsprintf( str, fmt, argptr );	/* prints string to buffer	*/
    outtextxy( *xloc, *yloc, str );	/* Send string in graphics mode */
    *yloc += textheight( "H" ) + 2;	/* Advance to next line		*/

    va_end( argptr );			/* Close va_ functions		*/

    return( cnt );			/* Return the conversion count	*/
  }

/*...........................................................................
	Save the current screen contents

        In	:	params		Size of screen area and buffer pointer
*/
save_screen ( MENU *params )
  {
    int 	  i, j;
    unsigned int  size;

    if ((params -> buff = malloc ( (params -> width + 2)
         * (params -> optmax + 4) * 2)) == NULL) {
      cprintf("\7\nUnable to allocate necessary memory");
      exit(0);
    }
    gettext ( params -> x,
  	      params -> y,
	      params -> x + params -> width + 1,
	      params -> y + params -> optmax + 3,
	      params -> buff );
    params -> new = 0;
  }
/*...........................................................................
	Draw the menu outline and text
*/
draw_menu ( MENU *params, char *title, char *(*opt_list))
  {
    int  i, j;

    char    BOXRJX = 182,		/* Box drawing characters */
            BOXHBX = 196,
	    BOXLJX = 199,
            BOXRJ = 185,
            BOXVB = 186,
            BOXRT = 187,
            BOXRB = 188,
            BOXLB = 200,
            BOXLT = 201,
            BOXBJ = 202,
            BOXTJ = 203,
            BOXLJ = 204,
            BOXHB = 205,
            BOXCJ = 206;

      gotoxy (params -> x, params -> y);
      putch(BOXLT);
      for ( j = 0; j < params -> width; j++ )
        putch(BOXHB);
      putch(BOXRT);

      gotoxy (params -> x, params -> y + 1);
      putch (BOXVB);
      for ( j = 0; j < params -> width; j++ )
        putch(' ');
      gotoxy ( params -> x + 2, params -> y + 1);
      highvideo();
      cprintf( title );
      normvideo();
      gotoxy( params -> x + params -> width + 1, params -> y + 1);
      putch(BOXVB);

      gotoxy (params -> x, params -> y + 2);
      putch(BOXLJX);
      for ( j = 0; j < params -> width; j++ )
        putch(BOXHBX);
      putch(BOXRJX);

      for ( i = 0; i < params -> optmax; i++ ) {
        gotoxy ( params -> x, params -> y + i + 3 );
        putch(BOXVB);
        for ( j = 0; j < params -> width; j++ )
          putch(' ');
        gotoxy ( params -> x + 2, params -> y + i + 3);
        cprintf( *(opt_list + i) );
        gotoxy( params -> x + params -> width + 1, params -> y + i + 3);
        putch(BOXVB);
      }
      gotoxy (params -> x, params -> y + params -> optmax + 3 );
      putch(BOXLB);
      for ( j = 0; j < params -> width; j++ )
        putch(BOXHB);
      putch(BOXRB);
  }

/*..........................................................................
	Restore screen and free up allocated buffer storage

*/
restore_screen ( MENU *params )
  {
    if ( !graphic ) {
      puttext ( params -> x,
	        params -> y,
		params -> x + params -> width + 1,
		params -> y + params -> optmax + 3,
		params -> buff );
      free (params -> buff);
      params -> new = 1;
    }
  }
/*............................................................................
	Highlight the current menu option
*/
high_light_line ( MENU *params, char *(*opt_list) )
  {
    if ( !graphic ) {
      highvideo();
      gotoxy ( params -> x + 2, params -> y + params -> opt + 2 );
      cprintf( *(opt_list + params -> opt - 1 ));
      normvideo();
    }
  }
/*............................................................................
	Draw the current menu line in normal video
*/
normal_line ( MENU *params, char *(*opt_list) )
  {
    if ( !graphic ) {
      normvideo();
      gotoxy ( params -> x + 2, params -> y + params -> opt + 2 );
      cprintf( *(opt_list + params -> opt - 1 ));
    }
  }

/*............................................................................
	Menu main entry point

*/

menu_disp (MENU *params,
	   char *title,
	   char *option, ...)
  {
    int       i, j;
    char      ch;

    if (params -> new)
      save_screen ( params );
    draw_menu ( params, title, &option );
    do {
      high_light_line ( params, &option );
      ch = getch();
      normal_line ( params, &option );
      if ((ch == ABORT) || (ch == ESC) || (ch == CR)) {
	if (ch != CR)
	  restore_screen ( params );
        return (ch == CR);
      }
      if (ch == 0) {
	ch = getch();
	if (ch == 72)
	  (params -> opt)--;
	if (ch == 80)
	  (params -> opt)++;
	if ( params -> opt < 1 )
	    params -> opt = params -> optmax;
	if ( params -> opt > params -> optmax )
	    params -> opt = 1;
      }
    } while (1);

  }